# kadis Leader Macros

| Sequence | Mnemonic                | Description                                |
|----------|-------------------------|--------------------------------------------|
| P C      | Proxy Cadey             | Proxytag for Cadey                         |
| P N      | Proxy Nicole            | Proxytag for Nicole                        |
| P J      | Proxy Jessie            | Proxytag for Jessie                        |
| P A      | Proxy Ashe              | Proxytag for Ashe                          |
| P S      | Proxy Sephie            | Proxytag for Sephie                        |
| P M      | Proxy Mai               | Proxytag for Mai                           |
| G I E    | Go If Err               | Inserts an `if err != nil` sequence        |
| G B      | Go Build                | `go build`                                 |
| G B A    | Go Build All            | `go build ./...`                           |
| G T      | Go Test                 | `go test`                                  |
| G T A    | Go Test All             | `go test ./...`                            |
| N B      | Nix Build               | `nix-build`                                |
| N B D    | Nix Build Docker        | `nix-build docker.nix`                     |
| N O R    | Nix Os Rebuild          | `sudo nixos-rebuild switch`                |
| N O U    | Nix Os Upgrade          | `sudo nixos-rebuild switch --upgrade`      |
| N N P    | Nix New Project         | new project boilerplate                    |
| K G D    | Kube Get Deployments    | Gets kubectl deployments                   |
| K G P    | Kube Get Pods           | Gets kubectl pods                          |
| K G S    | Kube Get Services       | Gets kubectl services                      |
| K G I    | Kube Get Ingresses      | Gets kubectl ingresses                     |
| K G N    | Kube Get Nodes          | Gets kubectl nodes                         |
| K L      | Kube Logs               | Gets kubectl logs                          |
| K L D    | Kube Logs Deployment    | Gets kubectl logs for a deployment         |
| K V      | Kube Version            | `kubectl version`                          |
| K I      | Kube Interactive        | `kubectl exec -it`                         |
| K E      | Kube Edit               | `kubectl edit`                             |
| K E D    | Kube Edit Deployment    | `kubectl edit deployment/`                 |
| K D      | Kube Describe           | `kubectl describe`                         |
| K N      | Kube Namespace          | `kubens`                                   |
| K C      | Kube Context            | `kubectx`                                  |
| G P      | Git Push                |                                            |
| G F P    | Git Force-Push          |                                            |
| G U      | Git Update              | runs git pull                              |
| G A      | Git Add                 | `git add .`                                |
| G D      | Git Diff                |                                            |
| G D S    | Git Diff Staged         |                                            |
| G L      | Git Log                 |                                            |
| G L O    | Git Log Oneline         |                                            |
| G O      | Git checkOut            |                                            |
| G O B    | Git checkOut new-Branch |                                            |
| G S      | Git Status              |                                            |
| G C      | Git Commit              |                                            |
| G C A    | Git Commit Amend        |                                            |
| E X      | Emacs alt-X             | opens the M-x menu                         |
| P N B    | Pasta Non-Binary        |                                            |
| P B M    | Pasta Breathe Manually  |                                            |
| S R      | Systemctl Restart       |                                            |
| S R U    | Systemctl Restart User  |                                            |
| S E      | Systemctl Enable        |                                            |
| S E U    | Systemctl Enable User   |                                            |
| S D      | Systemctl Disable       |                                            |
| S D U    | Systemctl Disable User  |                                            |
| S S      | Systemctl Stop          |                                            |
| S S U    | Systemctl Stop User     |                                            |
| S K      | Systemctl Kill          |                                            |
| S K U    | Systemctl Kill User     |                                            |
| M H      | Mara Hacker             |                                            |
| M W      | Mara What               |                                            |
| M T      | Mara Thonk              |                                            |
